=== test/epic/Makefile ===
test:
	-rm -r Epic
	-rm -r tests/bin
	mkdir tests/bin
	agda --epic RunTests.agda
	./RunTests
