=== debian/changelog ===
agda (2.3.2.2-1) unstable; urgency=low

  * [244f29d] Use new watch file template
  * [16a3f05] Imported Upstream version 2.3.2.2
  * [bdb8574] Update BDs to match cabal file
  * [9bc56ee] debian/patches/support-alex-3.1: Remove patch applied upstream
    in this release

 -- Iain Lane <laney@debian.org>  Wed, 06 Nov 2013 09:59:36 +0000

agda (2.3.2.1-2) unstable; urgency=low

  * [da376f6] Update BDs per .cabal; extend hashable, remove packages provided
    by ghc
  * [e21e765] Cherry-pick from upstream: Suppoert Alex 3.1.x
  * [2263659] Remove "dist" generated files accidently commited

 -- Iain Lane <laney@debian.org>  Sat, 19 Oct 2013 11:58:05 +0100
