## agda 2.4.0.2

=== debian/changelog ===
agda (2.4.0.2-2) unstable; urgency=medium

  * [e33e7a9] Pregenerate the Primitive.agdai interface file in
    libghc-agda-dev, since agda users typically can't write to that
    directory.  Fixes agda-stdlib build.

 -- Colin Watson <cjwatson@debian.org>  Mon, 11 Aug 2014 11:55:48 +0100

agda (2.4.0.2-1) unstable; urgency=medium

  * [6e140ac] Imported Upstream version 2.4.0.2
  * [2049fc8] Update Build-Depends to match control
  * [93dc4d4] Install the new primitives
  * [e48f40f] Fix typo dev→doc

 -- Iain Lane <laney@debian.org>  Tue, 05 Aug 2014 06:38:12 +0100
