=== debian/control ===
--- 
+++ 
@@ -8,48 +8,68 @@
                cdbs (>> 0.4.58),
                ghc (>= 7.6),
                ghc-ghci,
+               libghc-binary-dev (>= 0.6),
+               libghc-binary-dev (<< 0.8),
+               libghc-boxes-dev (>= 0.1.3),
+               libghc-boxes-dev (<< 0.2),
+               libghc-data-hash-dev (>= 0.2.0.0),
+               libghc-data-hash-dev (<< 0.3.0.0),
+               libghc-equivalence-dev (>= 0.2.4),
+               libghc-equivalence-dev (<< 0.3),
                libghc-geniplate-dev (>= 0.6.0.3),
                libghc-geniplate-dev (<< 0.7),
                libghc-hashable-dev (>= 1.2.1.0),
                libghc-hashable-dev (<< 1.3),
                libghc-hashtables-dev (>= 1.0),
                libghc-hashtables-dev (<< 1.2),
-               libghc-haskeline-dev (>= 0.6.3.2),
+               libghc-haskeline-dev (>= 0.7),
                libghc-haskeline-dev (<< 0.8),
                libghc-mtl-dev (>= 2.1.1),
                libghc-mtl-dev (<< 2.2),
                libghc-parallel-dev (<< 3.3),
+               libghc-transformers-dev (>= 0.3),
+               libghc-transformers-dev (<< 0.4),
                libghc-unordered-containers-dev (>= 0.2),
                libghc-unordered-containers-dev (<< 0.3),
                libghc-xhtml-dev (>= 3000.2),
                libghc-xhtml-dev (<< 3000.3),
                libghc-zlib-dev (>= 0.4.0.1),
                libghc-zlib-dev (<< 0.6),
+               libghc-strict-dev (>= 0.3.2),
+               libghc-strict-dev (<< 0.4),
                libghc-src-exts-dev (>= 1.9.6),
                libghc-src-exts-dev (<< 1.15),
-               libghc-quickcheck2-dev (>= 2.3),
-               libghc-quickcheck2-dev (<< 2.7),
+               libghc-stmonadtrans-dev (>= 0.3.2),
+               libghc-stmonadtrans-dev (<< 0.4),
                libghc-text-dev (>= 0.11),
-               libghc-text-dev (<< 0.12),
-               happy (>= 1.15),
+               libghc-text-dev (<< 1.2),
+               libghc-quickcheck2-dev (>= 2.7.5),
+               libghc-quickcheck2-dev (<< 2.8),
+               happy (>= 1.19.3),
                happy (<< 2),
-               alex (>= 2.3.1),
+               alex (>= 3.1.0),
                alex (<< 3.2),
                libncurses5-dev
 Build-Depends-Indep: ghc-doc,
                      libghc-binary-doc,
+                     libghc-boxes-doc,
+                     libghc-data-hash-doc,
+                     libghc-equivalence-doc,
                      libghc-geniplate-doc,
                      libghc-hashable-doc,
                      libghc-hashtables-doc,
                      libghc-haskeline-doc,
                      libghc-mtl-doc,
                      libghc-parallel-doc,
+                     libghc-stmonadtrans-doc,
+                     libghc-text-doc,
+                     libghc-transformers-doc,
                      libghc-unordered-containers-doc,
                      libghc-xhtml-doc,
                      libghc-zlib-doc,
-                     libghc-src-exts-doc, 
+                     libghc-strict-doc,
+                     libghc-src-exts-doc,
                      libghc-quickcheck2-doc,
-                     libghc-text-doc,
 Standards-Version: 3.9.4
 Vcs-Browser: http://git.debian.org/?p=pkg-haskell/agda.git;a=summary
 Vcs-Git: git://git.debian.org/git/pkg-haskell/agda.git
