## agda 2.4.2.2

=== debian/changelog ===
agda (2.4.2.2-4build1) wily; urgency=medium

  * Rebuild for new GHC ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 16 Aug 2015 09:51:20 +0100

agda (2.4.2.2-4) unstable; urgency=medium

  * [d59dba4] Revert modification of upstream source in
    a4109c2c88ab582bbc3141cd9a87373c3509c97b. We're patches unapplied.
  * [570458a] Cherry-pick upstream patch to build with cpphs 1.19 (Closes:
    #793194)

 -- Iain Lane <laney@debian.org>  Tue, 04 Aug 2015 14:46:23 +0100

agda (2.4.2.2-3) unstable; urgency=medium

  * Fix dependency on hashtables

 -- Joachim Breitner <nomeata@debian.org>  Wed, 01 Jul 2015 19:26:22 +0200

agda (2.4.2.2-2) unstable; urgency=medium

  * [d5cf60f] Depend on ${shlibs:Depends}, to get libc (& maybe other) deps

 -- Iain Lane <laney@debian.org>  Wed, 20 May 2015 13:08:33 +0100

agda (2.4.2.2-1) unstable; urgency=medium

  * New upstream release.
  * [1d76e9e] Bump BDs in line with Agda.cabal
  * [03480b1] Use ${source:Upstream-Version} substvar to generate the
    Recommends
  * [a164dc2] Drop patch, applied (in spirit) upstream.
  * [9a45428] Drop Build-Depends{,-Indep} on packages now provided by ghc
  * [87544db] debian/rules: Use LC_ALL=C.UTF-8 otherwise cpphs dies when
    parsing the source

 -- Iain Lane <laney@debian.org>  Wed, 20 May 2015 12:09:52 +0100

agda (2.4.2-1) unstable; urgency=medium

  * [6770868] Imported Upstream version 2.4.2
  * [3d550e3] Add patch from Joachim to allow transformers 0.4 and mtl 2.3
  * [38f0ec9] Add cpphs BD, requied by cabal file

 -- Iain Lane <laney@debian.org>  Tue, 23 Sep 2014 09:58:31 +0100
